;
; 	 *******************************************************************
;	 *          SMALL GRAY SCALE LIBRARY FOR TI-86 VERSION 1.0         *
;	 *                 Written by Etienne Mansot                       *
;	 *                             2001                                *
;	 *-----------------------------------------------------------------*
;	 * This is an optimized library of basic routines for gray	       *
;	 * scale graph mode (with Down+Left bug patch).Version for         *
;	 * 4 levels of gray.								 96 bytes only *
;	 *******************************************************************
;
;	If you want to use these routines you have to define this variables:

Page_Bpl1 = Bpl1		; you can use $3C which will be memory $FC00->$FFFF
Page_Bpl2 = Bpl2		; You can use $37 which will be momery $F700->$FB00

;+-------------------------------------------------------------------------+
;|						Open gray scale graph mode                         |
;+-------------------------------------------------------------------------+
;| Parameters:	none                                                       |
;+-------------------------------------------------------------------------+
;| Returns:		nothing                                                    |
;+-------------------------------------------------------------------------+
;| Registers destroyed: HL, DE, BC, A                                      |
;+-------------------------------------------------------------------------+
;| Comments:	Iinitialize interrupt routine					           |
;+-------------------------------------------------------------------------+

OpenGray:
	di
	ld hl,IntRoutine
	ld a,(hl)
	ld de,$D2FE
	ld bc,IntRoutineEnd-IntRoutine
	ldir
	ld hl,$D3C5
	ld de,-$28
	ld b,5
OpenGrayChecksum:
	add a,(hl)
	add hl,de
	djnz OpenGrayChecksum
	ld (hl),a
	set 2,(iy+$23)
	ei
	ret

;+-------------------------------------------------------------------------+
;|						Close gray scale graph mode                        |
;+-------------------------------------------------------------------------+
;| Parameters:	none                                                       |
;+-------------------------------------------------------------------------+
;| Returns:		nothing                                                    |
;+-------------------------------------------------------------------------+
;| Registers destroyed: A, BC, DE, HL                                      |
;+-------------------------------------------------------------------------+
;| Comments:	After closing gray scale graph mode it clears bitplanes    |
;|          	and sets LCD to display standard memory area ($FC00)       |
;+-------------------------------------------------------------------------+

CloseGray:
	res 2,(iy+$23)
	ld a,$3C
	out (0), a
ClearPage:			; You can call this routine alone ti clear bitplanes
	ld hl,Page_Bpl1+$C0*$100
	call Clear1024
	ld hl,Page_Bpl2+$C0*$100
Clear1024:
	ld d,h
	ld e,l
	inc de
	ld (hl),0
	ld bc,1023
	ldir
	ret

;+-------------------------------------------------------------------------+
;|							The interrupt routine	                       |
;+-------------------------------------------------------------------------+

IntRoutine:
	push af
	in a,($03)
	res 0,a
	out ($03),a
	push hl
	ld hl,IntPages
IntCounter = $+ $D2FE-IntRoutine+1
	ld a,0
	cp 6
	jr c,DisplayPages
	xor a
DisplayPages:
	inc a
	ld (IntCounter),a
	add a,l
	ld l,a
	ld a,(hl)
	out (0),a
	pop hl
	pop af
	ret
IntPages = $+ $D2FE-IntRoutine-1
	.db Page_Bpl1,Page_Bpl1
	.db Page_Bpl1,Page_Bpl1
	.db Page_Bpl2,Page_Bpl2
IntRoutineEnd:

;+-------------------------------------------------------------------------+